# Get historical fungible token contract rates

Get a paginated list of historical rates for a fungible token within the given time range by its contract package hash.

```
GET /ft/{contract_package_hash}/rates
```

## Query params

| Query param   | Description                                                                         |
| ------------- | ----------------------------------------------------------------------------------- |
| `currency_id` | [Currency](https://docs.cspr.cloud/rest-api/currency) identifier (required)         |
| `dex_id`      | [DEX](https://docs.cspr.cloud/rest-api/dex) identifier                              |
| `from`        | Start of the range in the [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format |
| `to`          | End of the range in the [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format   |

## Sorting

| Property    | Description             |
| ----------- | ----------------------- |
| `timestamp` | Sort rates by timestamp |

Default sorting is `timestamp DESC`

## Optional properties

None

## Response

[`PaginatedResponse`](https://docs.cspr.cloud/documentation/overview/pagination)[`<FTRate>`](https://docs.cspr.cloud/rest-api/fungible-token-rate)

## Example

```bash
curl -X 'GET' \
  'https://api.cspr.cloud/ft/F5E3729B502597FDD7BE9ECEDB6F73E4530F5E8A4C809F269D757677CBE49B78/rates?currency_id=1' \
  -H 'accept: application/json' \
  -H 'authorization: 55f79117-fc4d-4d60-9956-65423f39a06a'
```

```json
{
  "data": [
    {
      "amount": "0.00012126881",
      "transaction_hash": "3124a6f8b33bde9754e37bfb87b5104aaad96678fcb5a6389614860bc41d657d",
      "token_contract_package_hash": "f5e3729b502597fdd7be9ecedb6f73e4530f5e8a4c809f269d757677cbe49b78",
      "dex_id": 2,
      "currency_id": 1,
      "timestamp": "2025-11-12T09:47:18Z"
    },
    {
      "amount": "0.000116637406",
      "transaction_hash": "940ab4be6bb0536a7f88378121a0b78fe9646be66be24265a45c5714558f5989",
      "token_contract_package_hash": "f5e3729b502597fdd7be9ecedb6f73e4530f5e8a4c809f269d757677cbe49b78",
      "dex_id": 2,
      "currency_id": 1,
      "timestamp": "2025-11-12T09:46:48Z"
    },
    ...
    {
      "amount": "0.000082911945",
      "transaction_hash": "757ac982f71b2fb709bdc01bdcefbc3ef28b20a7a1a2f12de0ed9d8e9be62d4f",
      "token_contract_package_hash": "f5e3729b502597fdd7be9ecedb6f73e4530f5e8a4c809f269d757677cbe49b78",
      "dex_id": 2,
      "currency_id": 1,
      "timestamp": "2025-11-12T09:43:09Z"
    }
  ],
  "item_count": 1971,
  "page_count": 198
}
```
